; MSBV.LSP   fr TRICSY-ST   Mai 2004
;
; 14.10.2004 KBO  OK Button now inserts the selected block

(prompt ".")

;********************* MSBV **************************************************
(defun ms:msbv ( / make_block make_page text_edit group_edit get_dosnam
                   pos_liste make_group action bl_move_copy insert_view_def
                   del_page test_update group_del e asw ld vblock text
                   Xref_Char )

     (newerr "ms:msbv > msbv")

     (setq lastpick "ProGAPlan")                 ;  Schlsselwort fr Hilfe

     (setq bvins_dir bvsld_dir)
     (dir_exist bvins_dir bvgrp_file)            ; Gruppen-Verzeichnis vorhanden?
     (if (not (findfile bvdcl_file)) (progn
         (alert (strcat (C_GT "ERR_FIND_DCL_1") bvdcl_file (C_GT "ERR_FIND_DCL_2")))
         (olderr)
         (exit)
     ))

     (if (not $TRIC_DCL_ID$) (progn
         (setq $TRIC_DCL_ID$ (load_dialog bvdcl_file))
     ))

     (if (<= $TRIC_DCL_ID$ 0) (progn
         (alert (strcat (C_GT "ERR_LOAD_DCL_1") bvdcl_file (C_GT "ERR_LOAD_DCL_2")))
         (olderr)
         (exit)
     ))


  ;********************* POSITION SEITE/GRUPPE *********************************
  (defun pos_liste (bit / fn pos msbv_liste dos_liste uli_dos uli_msbv n
                          npos udos umsbv c)
      ;;bit:  0 = Gewerk, 1 = Gruppe, 2 = Seite
      (newerr "pos_liste > msbv")

      (set_tile "msg" "")
      (if (not (new_dialog "msbv_new_pos0" $TRIC_DCL_ID$)) (progn
          (alert (C_GT "ERR_LOAD_DCL"))
          (olderr)
          (exit)
      ))

      (cond
          ((= bit 0) ;; BIBLIOTHEK
              (setq fn          (strcat bvsld_dir "\\tsmb.dir"))
              (setq pos         (atoi select_gewerk))
              (setq dos_liste   gewerk_dir)
              (setq msbv_liste  gewerk_nam)
              (setq lastpick   "gewerk_positionieren")
              (set_tile "l_label" (C_GT "POS_GEWERK"))
          )

          ((= bit 1)  ;; GRUPPE
              (setq fn          (strcat bvsld_dir "\\" gewerk "\\tsmb.dir"))
              (setq pos         (atoi select_group))
              (setq dos_liste   group_dir)
              (setq msbv_liste  group_nam)
              (setq lastpick   "gruppe_positionieren")
              (set_tile "l_label" (C_GT "POS_GROUP"))
          )
          ((= bit 2)   ;; SEITE
              (setq fn          (strcat bvsld_dir "\\"gewerk "\\" group "\\tsmb.dir"))
              (setq pos         (atoi select_page))
              (setq dos_liste   dir_dos)
              (setq msbv_liste  dir_msbv)
              (setq lastpick   "seite_positionieren")
              (set_tile "l_label" (C_GT "POS_PAGE"))
          )
      ) ; cond

      (set_tile "msg" (nth pos msbv_liste))
      (setq  n         0)
      (setq  uli_dos  '())
      (setq  uli_msbv '())

      (while (< n (length msbv_liste))
          (if (/= pos n) (progn
              (setq uli_dos  (append uli_dos  (list (nth n dos_liste))))
              (setq uli_msbv (append uli_msbv (list (nth n msbv_liste))))
          ))
          (setq n (1+ n))
      )
	  (if uli_dos (progn
	      (make_list   "liste"  uli_msbv)
	  )(progn
	      (make_list   "liste"  '("")) ; es mu eine leere Stringliste bergeben werden!
	  ))
      (action_tile "liste"  "(setq npos (atoi $value))")
      (action_tile "ok"     "(done_dialog 1)")
      (action_tile "cancel" "(done_dialog)")
      (action_tile "help"   "(c_help)")

      (setq c (start_dialog))

      (if (and npos (= c 1)) (progn
          (setq n 0 udos '() umsbv '())
          (while (< n (length uli_dos))
              (if (= n npos) (progn
                  (setq udos  (append udos  (list (nth pos dos_liste ))))
                  (setq umsbv (append umsbv (list (nth pos msbv_liste))))
              ))
              (setq udos  (append udos  (list (nth n uli_dos ))))
              (setq umsbv (append umsbv (list (nth n uli_msbv))))
              (setq n (1+ n))
          )

          (save_mnu fn udos umsbv)

          (if (= bit 0) (progn
              (setq gewerk_dir    udos)
              (setq gewerk_nam    umsbv)
              (setq select_gewerk (itoa npos))
			  (if gewerk_dir (progn
	              (make_list "gewerk_list" umsbv)
    	          (set_tile  "gewerk_list" select_gewerk)
			  )(progn
	              (make_list "gewerk_list" '(""))
			  ))
          ))
          (if (= bit 1) (progn
              (setq group_dir    udos)
              (setq group_nam    umsbv)
              (setq select_group (itoa npos))
 			  (if group_dir (progn
				(make_list "group_list" umsbv)
		        (set_tile  "group_list" select_group)
			  )(progn
	              (make_list "group_list" '(""))
			  ))
          ))
          (if (= bit 2) (progn
              (setq dir_dos     udos)
              (setq dir_msbv    umsbv)
              (setq select_page (itoa npos))
			  (if dir_dos (progn
	              (make_list "page_list" umsbv)
    	          (set_tile  "page_list" select_page)
			  )(progn
	              (make_list "page_list" '(""))
			  ))
          ))
      ))

      (set_tile "msg" msg)
      (olderr)
      (setq lastpick "msbv_allgemein" ret ret)
  )

  ;********************* GEWERK LSCHEN ****************************************
  (defun gewerk_del ( / bat dat_nam fn n del insert)

      (newerr "gewerk_del > msbv")
      (setq line (strcat bvins_dir "\\" gewerk))
      (C_DelTree line)

      (set_tile "msg" (C_GT "ACT_DATABASE"))
      (setq fn (open (strcat bvins_dir "\\tsmb.dir") "w") n 0)
      (repeat (length gewerk_dir)
          (if (/= (nth n gewerk_dir) gewerk) (progn
              (setq line  (strcat (nth n gewerk_dir) " " (nth n gewerk_nam)))
              (write-line (C_ConvertWINtoDOS line) fn)
          ))
          (setq n (1+ n))
      )
      (setq fn (close fn))
      (setq select_gewerk "0")
      (setq select_group  "0")
      (setq select_page   "0")
      (setq gewerk nil)
      (setq group nil )
      (setq page nil  )
      (cfg)

      (olderr)
  )


  ;********************* GRUPPE LSCHEN ****************************************
  (defun group_del( / bat dat_nam fn n del insert)

      (newerr "group_del > msbv")
      (setq line (strcat bvins_dir "\\" gewerk "\\" group))
      (C_DelTree line)

      (set_tile "msg" (C_GT "ACT_DATABASE"))
      (setq fn (open (strcat bvins_dir "\\" gewerk "\\tsmb.dir") "w") n 0)
      (repeat (length group_dir)
          (if (/= (nth n group_dir) group) (progn
              (setq line (strcat (nth n group_dir) " " (nth n group_nam)))
              (write-line (C_ConvertWINtoDOS line) fn)
          ))
          (setq n (1+ n))
      )
      (setq fn (close fn))
      (setq select_group "0")
      (setq select_page  "0")
      (setq group        nil)
      (setq page         nil)
      (cfg)

      (olderr)
  )


  ;********************* SEITE VERSCHIEBEN/KOPIEREN ****************************
  (defun copy_move_page (bit / cancel_act group_act is_ok bat n fi)
      (newerr "copy_move_page > msbv")

      (set_tile "msg" "")
      (setq ret nil)
      (if (not (new_dialog "msbv_copy_move_page0" $TRIC_DCL_ID$)) (progn
          (alert (strcat (C_GT "ERR_LOAD_DCL_1") bvdcl_file (C_GT "ERR_LOAD_DCL_2")))
          (olderr)
          (exit)
      ))
      (setq o_select_group  select_group)      ;Variablen sichern
      (setq o_select_gewerk select_gewerk)
      (setq o_dir_dos       dir_dos)
      (setq o_dir_msbv      dir_msbv)
      (setq o_select_page   select_page)
      (setq o_bl_nam_dos    bl_nam_dos)
      (setq o_bl_nam_msbv   bl_nam_msbv)
      (setq o_page          page)
      (setq o_group         group)
      (setq o_gewerk        gewerk)
      (setq ret             nil)

        ; VARIABLEN RESTAURIEREN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        (defun cancel_act ()
            (newerr "cancel_act > msbv")

            (setq select_group o_select_group)
            (setq select_gewerk o_select_gewerk)
            (setq dir_dos o_dir_dos)
            (setq dir_msbv o_dir_msbv)
            (setq select_page o_select_page)
            (setq page o_page)
            (setq group o_group)
            (setq gewerk o_gewerk)
            (setq bl_nam_dos o_bl_nam_dos)
            (setq bl_nam_msbv o_bl_nam_msbv)
            (setq ret nil) ;Rckgabe
            (olderr)
        )

        ; AKTION GEWERKE-SLIDER <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        (defun gewerk_act (var / l_liste)
            (newerr "gewerk_act > msbv")

            (setq select_page  "0") ;aktuelle Seite 1
            (setq select_group "0") ;aktuelle Gruppe
            (setq gewerk (nth(atoi var) gewerk_dir)) ;GewerkeVerzeichnis DOS
            (setq l_liste (gen_liste (strcat bvins_dir "\\" gewerk "\\tsmb.dir")))
            (setq dir_dos  (car l_liste))  ;Liste DOS
            (setq dir_msbv (cdr l_liste))  ;Liste MSBV
            (setq group_dir dir_dos)
            (setq group_nam dir_msbv)
            (setq select_gewerk var)      ;aktuelle Gruppe
            (if dir_dos (progn
	            (make_list "group_list" dir_msbv) ;Sliderliste Gruppe
                (group_act "0")
             	(set_tile "group_list" "0")
           )(progn
	            (make_list "group_list" '("")) ;Sliderliste leere Gruppe
                (make_list "page_list" '(""))  ;Sliderliste leere Seite
            ))
            (olderr)
        )

        ; AKTION GRUPPEN-SLIDER <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        (defun group_act (var / l_liste)
            (newerr "group_act > msbv")
            (setq select_page "0")
            (setq group        (nth (atoi var) group_dir))
            (setq l_liste      (gen_liste (strcat bvins_dir "\\" gewerk "\\" group "\\tsmb.dir")))
            (setq dir_dos      (car l_liste))
            (setq dir_msbv     (cdr l_liste))
            (setq select_group var)

            (if dir_dos (progn
	            (make_list "page_list" dir_msbv)
                (page_act "0")
	            (set_tile "page_list" "0")
			)(progn
	            (make_list "page_list" '(""))
            ))
            (olderr)
        )

        ; AKTION SEITEN-SLIDER <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        (defun page_act (var / l_liste)
            (newerr "page_act > msbv")

            (setq page        (nth (atoi var) dir_dos))
            (setq l_liste     (gen_liste (strcat bvins_dir "\\" gewerk "\\" group "\\" page "\\tsmb.ins")))
            (setq bl_nam_dos  (car l_liste))
            (setq bl_nam_msbv (cdr l_liste))
            (setq select_page var)

            (set_tile "page_list" select_page)
            (olderr)
        )

        ; AKTION SEITEN-SLIDER <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        (defun is_ok ( / ret)
            (newerr "is_ok > msbv")

            (setq ret nil)
            (if (not dir_dos) (progn
                (ms_msg (C_GT "PG_NO_SELECTED"))
            )(progn
                (if bl_nam_dos (progn
                    (ms_msg (C_GT "PG_NOT_EMPTY"))
                )(progn
                    (setq ret T)
                ))
            ))
            (set_tile "msg" (C_GT "SEL_PG_GROUP"))
            (olderr)
            (setq ret ret)
        )

      ;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
      ; die eigentliche Funktion 'Copy_Move_Page' beginnt hier

      (make_list "gewerk_list" gewerk_nam)
      (set_tile "gewerk_list" select_gewerk)
      (gewerk_act select_gewerk)
      (make_list "group_list" group_nam)
      (set_tile "group_list" select_group)
      (group_act select_group)
      (if (= bit 1) (progn
          (set_tile "l_label" (C_GT "MOVE_PAGE"))
          (setq lastpick "Seite_verschieben")
      )(progn
          (set_tile "l_label" (C_GT "COPY_PAGE"))
          (setq lastpick "Seite_kopieren")
      ))
      (set_tile "msg" (C_GT "SEL_PG_GRP_GEW"))
      (set_tile "page" (strcat bvins_dir "\\" gewerk "\\" group "\\" page "\\*.*"))
      (action_tile "gewerk_list" "(gewerk_act $value)")
      (action_tile "group_list" "(group_act $value)")
      (action_tile "page_list" "(page_act $value)")
      (action_tile "help" "(c_help)")
      (action_tile "cancel" "(cancel_act)(done_dialog)")
      (action_tile "ok" "(if(is_ok)(done_dialog 1))")

      (if (= (start_dialog) 1) (progn

          (setq ret T)
          (if (= bit 1) (progn
              ;VERSCHIEBEN
              (setq line  (strcat  bvins_dir "\\" o_gewerk "\\" o_group "\\" o_page "\\*.*"))
              (setq line2 (strcat  bvins_dir "\\"   gewerk "\\"   group "\\"   page "\\*.*"))
              (C_COPY line line2)

              (setq line (strcat bvins_dir "\\" o_gewerk "\\" o_group "\\" o_page "\\*.*" ))
              (C_DEL line)
              (setq line (strcat bvins_dir "\\" o_gewerk "\\" o_group "\\" o_page ))
              (C_RD line)

              (setq fi (open (strcat bvins_dir "\\" o_gewerk "\\" o_group "\\tsmb.dir") "w"))
              (setq n 0)

              (repeat (length o_dir_dos)
                  (if (/= (nth n o_dir_dos) o_page) (progn
                      (setq line (strcat (nth n o_dir_dos) " " (nth n o_dir_msbv)))
                      (write-line (C_ConvertWINtoDOS line) fi)
                  ))
                  (setq n (1+ n))
              )
              (setq fi (close fi))

          )(progn
              ;SEITE KOPIEREN
              (setq ins (strcat bvsld_dir "\\tsmb.ins") n_bl_nam_dos '() n 0)
              (while (< n (length o_bl_nam_dos))
                  ;alte Seite abfahren und neue Namen fr alle Blcke vergeben
                  (setq n_bl_nam_dos (append n_bl_nam_dos (list (setq nam (get_dosnam nil T)))))
                  (setq fi (open ins "w"))
                  (write-line (C_ConvertWINtoDOS nam) fi)
                  (setq fi (close fi) n (1+ n))
              )
              (setq n 0)
              (while (< n (length n_bl_nam_dos))
                  (setq line  (strcat bvins_dir "\\" o_gewerk "\\" o_group "\\" o_page "\\" (nth n o_bl_nam_dos) ".*"))
                  (setq line2 (strcat bvins_dir "\\"   gewerk "\\"   group "\\"   page "\\" (nth n n_bl_nam_dos) ".*"))
                  (C_COPY line line2)
                  (setq n (1+ n))
              )
              (setq fi (open (strcat bvins_dir "\\" gewerk "\\" group "\\" page "\\tsmb.ins") "w"))
              (setq n 0)

              (repeat (length n_bl_nam_dos)
                  (setq line (strcat (nth n n_bl_nam_dos) " " (nth n o_bl_nam_msbv)))
                  (write-line (C_ConvertWINtoDOS line) fi)
                  (setq n (1+ n))
              )
              (setq fi (close fi))
             )
          )
          (setq select_gewerk o_select_gewerk)
          (setq select_group  o_select_group)
          (setq select_page   "0")
          (cfg)
      )(progn
          (setq ret nil)
      ))
      (set_tile "msg" (C_GT "SELECT_FUNCTION"))
      (olderr)
      (setq ret ret)
  )


  ;********************* SEITE LSCHEN *****************************************
  (defun del_page( / bat fn zeile n dat_nam)
      (newerr "del_page > msbv")
      (setq dir_dos     (del_elem_liste page dir_dos))  ;Listen updaten
      (setq dir_msbv    (del_elem_liste (nth (atoi select_page) dir_msbv) dir_msbv))
      (setq select_page "0")                ;auf 1. Seite setzen
      (setq dat_nam     (strcat bvins_dir "\\tsmb.ins"))

      ;Listen sichern
      (save_mnu (strcat bvins_dir "\\" gewerk "\\" group "\\tsmb.dir") dir_dos dir_msbv)
      (cfg)     ;Stand speichern
      (if bl_nam_dos (progn
          (setq line (strcat  bvins_dir "\\" gewerk "\\" group "\\" page "\\*.ins"))
          (C_DEL line)
          (setq line (strcat bvins_dir "\\" gewerk "\\" group "\\" page "\\*.dwg"))
          (C_DEL line)
          (setq line (strcat bvins_dir "\\" gewerk "\\" group "\\" page "\\*.sld"))
          (C_DEL line)
      ))
      (setq line  (strcat bvins_dir "\\" gewerk "\\" group "\\" page ))
      (C_RD line)
      (olderr)
      (done_dialog 8)
  )


  ;*****************************************************************************
  ;** Bl_Move_Copy ***** BLCKE VERSCHIEBEN/KOPIEREN ***************************
  ; Action :
  ;   The function is the reaction to the event "Block Copy" or to the event
  ;   "Block Move".  It starts a new dialog to find out where to copy (or move)
  ;   the selected block.
  ;   Before you start this function, a block must be selected.
  ;
  (defun bl_move_copy (bit / action act_page cancel_act o_select_group o_dir_dos
                             o_dir_msbv o_select_page o_bl_nam_dos o_bl_nam_msbv
                             o_page o_group cancel_act act_group new_block_nam
                             old_block_nam change_pos_page ret)
      (newerr "bl_move_copy > msbv")
      (set_tile "msg" "")
      (setq ret nil) ;RCKGABE DER FUNKTION
      (if (not (new_dialog "msbv_move_copy0" $TRIC_DCL_ID$)) (progn
          (alert (strcat (C_GT "ERR_LOAD_DCL_1") bvdcl_file (C_GT "ERR_LOAD_DCL_2")))
          (exit)
      ))

      (setq o_select_group  select_group)   ; -- VARIABLEN SICHERN
      (setq o_select_gewerk select_gewerk)
      (setq o_dir_dos       dir_dos)
      (setq o_dir_msbv      dir_msbv)
      (setq o_select_page   select_page)
      (setq o_bl_nam_dos    bl_nam_dos)
      (setq o_bl_nam_msbv   bl_nam_msbv)
      (setq o_page          page)
      (setq o_group         group)
      (setq o_gewerk        gewerk)
      (setq old_block_nam   (strcat bvins_dir "\\" gewerk "\\" group "\\" page "\\" pick_block))

        ; VARIABLEN RESTAURIEREN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        (defun cancel_act()   ;  --  VARIABLEN RESTAURIEREN
            (setq select_group o_select_group)
            (setq select_gewerk o_select_gewerk)
            (setq dir_dos      o_dir_dos)
            (setq dir_msbv     o_dir_msbv)
            (setq select_page  o_select_page)
            (setq page         o_page)
            (setq group        o_group)
            (setq gewerk       o_gewerk)
            (setq bl_nam_dos   o_bl_nam_dos)
            (setq bl_nam_msbv  o_bl_nam_msbv)
            (setq ret nil) ;RCKGABE
        )

        ; AKTION SEITEN-SLIDER <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        ; Action :
        ;   Aux function for the Bl_Move_Copy.  It is called from Act_Group wich is
        ;   called from  Bl_Move_Copy.  They just continue the work of preparing
        ;   the dialog (Buttons, Lists and so on).  It is also called as reaction
        ;   to the event of selecting a new page in the "Copy/Move Block" dialog.

        (defun act_page (var / l_liste n icon)
            (setq page          (nth (atoi var) dir_dos))
            (setq l_liste       (gen_liste (strcat bvins_dir "\\" gewerk "\\" group "\\" page "\\tsmb.ins")))
            (setq bl_nam_dos    (car l_liste))
            (setq bl_nam_msbv   (cdr l_liste))
            (setq select_page   var)
            (setq next_block    (get_dosnam nil T))
            (setq copy_block_nam (strcat bvins_dir "\\" gewerk "\\" group "\\" page "\\" next_block))
            (setq new_block_nam  (strcat bvins_dir "\\" gewerk "\\" group "\\" page "\\" pick_block))
            (setq n              0)

            (repeat 12
                (if (< n 10) (progn
                    (setq icon (strcat "i0"(itoa n)))  ; Then icon = "i01" .. "i09"
                )(progn
                    (setq icon (strcat "i" (itoa n)))  ; else icon = "i10" .. "i12"
                ))

                (if bl_nam_dos (progn      ; Wenn Liste (Seite nicht leer)
                   (mode_tile icon 1)  ;     Button deaktivieren
                )(progn
                   (if (> n 0) (progn  ;    Else (Seite leer)
                       (mode_tile icon 1) ;    1. Button berspringen  (Deaktivieren)
                   )(progn
                       (mode_tile icon 0) ;    1. Button immer ein    (der erster)
                   ))
                ))
                (setq n (1+ n))
            ) ; repeat 12
            (if (or (/= group o_group) (/= page o_page) (/= gewerk o_gewerk))    ;Andere Seite oder Gruppe
                ; Ein Button mehr aktivieren wenn Block nicht vorhanden
                (if (and( not (member pick_block bl_nam_dos)) (< (length bl_nam_dos) 10)) (progn
                    (mode_tile (strcat "i0" (itoa (length bl_nam_dos))) 0)
                )(progn
                    (mode_tile (strcat "i"  (itoa (length bl_nam_dos))) 0)
                ))
            )
            ;+-
            (if (and (= group o_group) (= page o_page) (= gewerk o_gewerk) (= bit 1)) (progn
                ;gleiche Seite, Gewerk Und Gruppe
                (setq n 0)
                (repeat (length bl_nam_dos)
                    (if (/= (nth n bl_nam_dos) pick_block) (progn ; gleiche position kann/soll nicht
                        (if (< n 10) (progn                       ; selektiert werden
                            (mode_tile (strcat "i0" (itoa n)) 0)
                        )(progn
                            (mode_tile (strcat "i" (itoa n)) 0)
                        ))
                    ))
                    (setq n (1+ n))
                )
            ))
        ) ; defun Act_Page

        ; AKTION GEWERKE-SLIDER <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        (defun act_gewerk (var / l_liste n icon)
            (setq select_page  "0")                   ;aktuelle Seite 1
            (setq select_group "0")
            (setq gewerk (nth (atoi var) gewerk_dir))  ;Gruppenverzeichnis DOS
            (setq l_liste (gen_liste (strcat bvins_dir "\\" gewerk "\\tsmb.dir")))
            (setq dir_dos  (car l_liste))          ;Liste DOS
            (setq dir_msbv (cdr l_liste))          ;Liste MSBV
            (setq group_dir dir_dos)
            (setq group_nam dir_msbv)
            (setq select_gewerk var)             ;Aktuelle Gruppe

            (make_list "group_list" dir_msbv) ;Sliderliste Seite
            (set_tile  "group_list" "0")      ;Slider markieren
            (if dir_msbv (progn
                (act_group "0");Gltige Button aktivieren
            ))
        )

        ; AKTION GRUPPEN-SLIDER <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        (defun act_group (var / l_liste n icon)
            (setq select_page  "0")                   ;Aktuelle Seite 1
            (setq group        (nth(atoi var) group_dir))    ;Gruppenverzeichnis DOS
            (setq l_liste      (gen_liste (strcat bvins_dir "\\" gewerk "\\" group "\\tsmb.dir")))
            (setq dir_dos      (car l_liste))         ;Liste DOS
            (setq dir_msbv     (cdr l_liste))         ;Liste MSBV
            (setq select_group var)                   ;aktuelle Gruppe

            (make_list "page_list" dir_msbv) ;Sliderliste Seite
            (set_tile "page_list" "0");Slider markieren
            (if dir_msbv (progn
                (act_page "0")  ;Gltige Button aktivieren
            )(progn             ;Alle Button deaktivieren
                (setq n 0)
                (repeat 12
                    (if (< n 10) (progn
                        (setq icon (strcat "i0"(itoa n)))
                    )(progn
                        (setq icon (strcat "i" (itoa n)))
                    ))
                    (mode_tile icon 1)
                    (setq n (1+ n))
                )
            ))
        )

        ; BLOCK AUF SEITE POSITIONIEREN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        ; Argumente :
        ;    pos    -->  Position. 0 --> an 1. Stelle
        ;    msbv_nam
        ;    u_dos
        ;    u_msbv
        ;
        (defun change_pos_page(pos msbv_nam u_dos u_msbv / n)
            (cond
                ((= pos 0)
                    ; an 1. Position
                    (setq bl_nam_dos  (append (list pick_block) u_dos))
                    (setq bl_nam_msbv (append (list msbv_nam)   u_msbv))
                )

                ((>= (1+ pos) (length bl_nam_dos))
                    ; an letzter Position
                    (setq bl_nam_dos  (append u_dos  (list pick_block)))
                    (setq bl_nam_msbv (append u_msbv (list msbv_nam)))
                )

                (T
                    ; 2 ... 11 Position
                    (setq n 0 bl_nam_dos '() bl_nam_msbv '())
                    (repeat (length u_dos)
                        (if (= n pos) (progn
                            (setq bl_nam_dos  (append bl_nam_dos  (list pick_block)))
                            (setq bl_nam_msbv (append bl_nam_msbv (list msbv_nam)))
                        ))
                        (setq bl_nam_dos  (append bl_nam_dos  (list (nth n u_dos))))
                        (setq bl_nam_msbv (append bl_nam_msbv (list (nth n u_msbv))))
                        (setq n (1+ n))
                    )
                )
            )
        )

        ; --- act_move  ----  AKTION BLOCK VERSCHIEBEN/KOPIEREN <<<<<<<<<<<<<<
        ;
        ; Globale vars :
        ;    Pick_Block  --> Name of the block to be copied (moved)
        ;    Bl_Nam_DOS  --> List of block names in the destination page
        ;                    Is generated when selecting the destination (act_page)
        ;    Old_Block_Label --> Block name in MSBV (i.e. "Nessie")
        ;
        ; Argumente :
        ;    pos --> Positionsnummer in der ZielSeite
        ;
        (defun act_move (pos / u_dos u_msbv n msbv_nam ret)
            (setq ret 0)
            (cond
                ((and (= group o_group) (= page o_page) (= gewerk o_gewerk)) (progn
                    ;  --  Gewerk, Gruppe und Seite gleich
                    (setq u_dos '() u_msbv '() n 0)
                    (repeat (length bl_nam_dos)
                        (if (/= (nth n bl_nam_dos) pick_block) (progn
                            (setq u_dos  (append u_dos  (list (nth n bl_nam_dos))))
                            (setq u_msbv (append u_msbv (list (nth n bl_nam_msbv))))
                        )(progn
                            (setq msbv_nam (nth n bl_nam_msbv))
                        ))
                        (setq n (1+ n))
                    )
                    (change_pos_page  pos msbv_nam  u_dos u_msbv)
                    (save_mnu (strcat bvins_dir "\\" gewerk "\\" group "\\" page "\\tsmb.ins") bl_nam_dos bl_nam_msbv)
                    (setq selct_gewerk o_select_gewerk)
                    (setq select_page o_select_page)
                    (setq select_group o_select_group)
                    (setq ret 1)              ;Rckgabe ohne Shell-Operation
                )); Ende gleiche Gruppe gleiche Seite

                (T
                    ;  --  Gewerk,Gruppe oder Seite unterschiedlich (sonst)
                    (if(>=(length bl_nam_dos)12) (progn
                        ; die Zielseite hat kein Platz
                        (setq ret 0)
                        (ms_msg (C_GT "PAGE_FULL"))
                    )(progn
                         ;Block kopieren
                        (setq ret 2)
                        (if (= bit 1) (progn
                            (setq line  (strcat old_block_nam ".*"))
                            (setq line2 (strcat new_block_nam ".*"))
                            (C_COPY line line2)
                            (setq line (strcat old_block_nam ".*"))
                            (C_DEL line)
                        )(progn
                            (setq line  (strcat old_block_nam  ".*"))
                            (setq line2 (strcat copy_block_nam ".*"))
                            (C_COPY line line2)
                            (setq ins (open (strcat bvsld_dir "\\tsmb.ins") "w"))
                            (write-line (C_ConvertWINtoDOS next_block) ins)   ;Block-Nr. schreiben
                            (setq ins (close ins))
                        ))
                        (setq u_dos  '())
                        (setq u_msbv '())
                        (setq n      0)
                        (setq msbv_nam (nth (- (length o_bl_nam_dos)
                                               (length (member pick_block o_bl_nam_dos))) o_bl_nam_msbv))

                        (if (= bit 1) (progn
                            ; Wenn Verschieben alte Gruppe/Seite aktualisieren
                            (setq u_dos '() u_msbv '() n 0)
                            (repeat (length o_bl_nam_dos)   ;  BlockNamen entfernen
                                (if (/= (nth n o_bl_nam_dos) pick_block) (progn
                                    (setq u_dos  (append u_dos  (list (nth n o_bl_nam_dos ))))
                                    (setq u_msbv (append u_msbv (list (nth n o_bl_nam_msbv))))
                                ))
                                (setq n (1+ n))
                            )
                            (save_mnu (strcat bvins_dir "\\" o_gewerk "\\" o_group "\\" o_page "\\tsmb.ins") u_dos u_msbv)
                        )(progn
                            (setq pick_block next_block)
                        ))   ;if  "Verschieben"

                        ;Gewhlte Gruppe/Seite aktualisieren
                        (setq u_dos '() u_msbv '() n 0)
                        (if (member pick_block bl_nam_dos) (progn
                            (repeat (length bl_nam_dos)
                                (if (/= (nth n bl_nam_dos) pick_block) (progn
                                    (setq u_dos  (append u_dos  (list (nth n bl_nam_dos))))
                                    (setq u_msbv (append u_msbv (list (nth n bl_nam_msbv))))
                                ));if
                                (setq n (1+ n))
                            );repeat
                            (change_pos_page  pos msbv_nam  u_dos  u_msbv)
                        )(progn
                            (change_pos_page  pos msbv_nam  bl_nam_dos  bl_nam_msbv)
                        ))
                        (save_mnu (strcat bvins_dir "\\" gewerk "\\" group "\\" page "\\tsmb.ins") bl_nam_dos bl_nam_msbv)
                    ))
                )
            )
            (setq ret ret)
        ) ; defun Act_Move



        ; VERZWEIGUNG DER FUNKTIONEN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        (defun action ( / l_liste)
            (setq ret nil)
            (cond
                ((= $key "gewerk_list")         ;Anzeige der Gewerke
                    (act_gewerk $value)
                )

                ((= $key "group_list")          ;Anzeige der Seiten
                    (act_group $value)
                )

                ((= $key "page_list")           ;Button ein/aus  (??)
                    (act_page $value)
                )

                ((= (substr $key 1 1) "i")      ;Block verschieben/kopieren
                    (if (and (= group o_group) (= page o_page) (= gewerk o_gewerk) (= bit 2)) (progn
                        (ms_msg (C_GT "NOT_ON_SAME_PAGE"))
                    )(progn
                        (if (> (setq ret (act_move (atoi (substr $key 2))))0) (progn
                            ;wenn alles OK
                            (done_dialog)
                        ))
                    )) ; if gleiche Seite
                )  ; Fall "Verschieben / Kopieren"
            ) ; cond
        ) ; defun action


      ;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
      ;>>>Main Sub-Function >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
      (act_gewerk select_gewerk)
      (act_group select_group);SLIDER UND BUTTON AUFBAUEN
      (if (= bit 0) (progn
          (setq lastpick "Block_verschieben")
          (set_tile "l_label" (C_GT "MOVE_BLOCK"))
      ))
      (if (= bit 1) (progn
          (setq lastpick "Block_verschieben")
          (set_tile "l_label" (C_GT "MOVE_BLOCK"))
      )(progn
          (setq lastpick "Block_kopieren")
          (set_tile "l_label" (C_GT "COPY_BLOCK"))
      ))
      (set_tile "msg" (C_GT "SELECT_POSITION"))
      (setq x (dimx_tile "icon") y (dimy_tile "icon"))
      (start_image "icon")
      (slide_image 0 0 x y block_nam)
      (end_image)
      (mode_tile "icon" 1)
      (set_tile  "datnam" (strcat block_nam ".DWG"))
      (make_list "gewerk_list" gewerk_nam)
      (set_tile  "gewerk_list" select_gewerk)
      (make_list "group_list"  group_nam)
      (set_tile  "group_list"  select_group)
      (make_list "page_list"   dir_msbv)
      (set_tile  "page_list"   select_page)
      (action_tile "gewerk_list" "(action)")
      (action_tile "group_list"  "(action)")
      (action_tile "page_list"   "(action)")
      (action_tile "i00"         "(action)")
      (action_tile "i01"         "(action)")
      (action_tile "i02"         "(action)")
      (action_tile "i03"         "(action)")
      (action_tile "i04"         "(action)")
      (action_tile "i05"         "(action)")
      (action_tile "i06"         "(action)")
      (action_tile "i07"         "(action)")
      (action_tile "i08"         "(action)")
      (action_tile "i09"         "(action)")
      (action_tile "i10"         "(action)")
      (action_tile "i11"         "(action)")
      (action_tile "cancel"      "(cancel_act)(done_dialog)")
      (action_tile "help"        "(c_help)")
      (start_dialog)
      (setq lastpick "msbv_allgemein")
      (set_tile "msg" msg)
      (olderr)
      (setq ret ret)
  ) ; defun bl_move_copy

  ;****** End of Bl_Move_Copy **************************************************
  ;*****************************************************************************


  ;********************* PAN UND ZOOM FR DIA-AUSSCHNT *************************
  (defun insert_view_def (e / v_cent v_h v_size v_w ll ru c n ret p1 p2)
      (newerr "insert_view_def > c:msbv")

      (setq v_cent (getvar "viewctr"))   ;Momentaner Ausschnt
      (setq v_h    (getvar "viewsize"))
      (setq v_size (getvar "screensize"))
      (setq v_w    (* v_h (/ (car v_size)(cadr v_size))))
      (setq ll     (list (- (car v_cent) (* v_w 0.5))(- (cadr v_cent) (* v_h 0.5))))
      (setq ru     (list (+ (car v_cent) (* v_w 0.5))(+ (cadr v_cent) (* v_h 0.5))))
      (setq c      T)
      (setq txt    (C_GT "SLIDE_PROMPT_1"))
      (setq n      0)
      (setq ret    (cons ll ru))

      (initget (strcat (C_GT "PAN") " " (C_GT "VIEW")))
      (while c
          (setq p1 (getpoint txt))
          (cond
              ((and p1 (/= p1 (C_GT "PAN")) (/= p1 (C_GT "VIEW")) (/= p1 (C_GT "PREVIOUS")))
                  (if (setq p2 (getcorner p1 (C_GT "SLIDE_PROMPT_2"))) (progn
                      (entdel e)  ;Punkt lschen
                      (command "_.zoom" "_w" p1 p2)
                      (entdel e)   ;Punkt passend zum Ausschnitt wieder setzen
                      (setq n (1+ n))
                  ))
              )
              ((and p1 (= p1 (C_GT "PAN")) (/= p1 (C_GT "VIEW")) (/= p1 (C_GT "PREVIOUS")))
                  (if (setq p1 (getpoint (C_GT "MOVEMENT"))) (progn
                      (if (setq p2 (getpoint p1 (C_GT "SECOND_POINT"))) (progn
                          (command "_.pan" p1 p2)
                          (setq n (1+ n))
                      ))
                  ))
              )
              ((and p1 (/= p1 (C_GT "PAN")) (/= p1 (C_GT "VIEW")) (= p1 (C_GT "PREVIOUS")) (> n 0))
                  (entdel e);PUNKT LSCHEN
                  (command "_.zoom" "_p")
                  (entdel e);PUNKT PASSEND ZUM AUSSCHNITT WIEDER SETZEN
                  (setq n (1- n))
              )
              ((and p1 (/= p1 (C_GT "PAN")) (/= p1 (C_GT "VIEW")) (= p1 (C_GT "PREVIOUS")) (<= n 0))
                  (prompt (C_GT "NO_PREV_VIEW"))
              )
              (T(setq c nil))
          )
          (initget (C_GT "PAN_VIEW_PREV"))
          (setq txt (C_GT "SLIDE_PROMPT_3"))
      )

      (olderr)
      (setq ret ret);RCKGABE ALTER AUSSCHNT
  )


  ;********************* BLOCK UND DIA ERSTELLEN *******************************
  (defun make_block ( / fn zeile dos asw asx p1 p2 dat_nam ip ret e l_liste
                       ll ru end_point bez Org_Lay)

      (newerr "make_block > c:msbv")

      (setq ret 1)
      ;(c_PushVars)
      (setq o_snapmode (getvar "snapmode"))
      (setq o_cecolor  (getvar "cecolor" ))
      (setvar "cmddia" 0)

      (if (setq ip (getpoint (C_GT "INS_POINT"))) (progn
          (setvar  "pdmode" 3)
          (setvar  "cecolor" "1")
          (setq    Org_Lay (getvar "CLayer"))
          (command "._point" ip)

          (setq e (entlast))  ; Einfge PUNKT zum Lschen festhalten

          ; Auswahl der Objekte, die zum Block gehren sollen
          (prompt (C_GT "SEL_BLOCK_ELEM"))
          (if (setq asw (ssget)) (progn
              (prompt (C_GT "BLOCK_WAIT_MSG"))
              (ssdel e asw) ;FALLS PUNKT IM AUSWAHLSATZ, ENTFERNEN

              (setq l_liste (insert_view_def e)) ;AUSSCHNT DEFINIEREN, RET ALTEN AUSSCHNT
              (setq ll (car l_liste)) ;low left
              (setq ru (cdr l_liste)) ;right up

              (setq dos (get_dosnam nil T))          ;Blocknamen ermitteln
              (setq fn  (open (strcat bvsld_dir "\\tsmb.ins") "w"))
              (setq line dos)
              (write-line (C_ConvertWINtoDOS line) fn);Block-nr. schreiben
              (setq fn (close fn))
              (setq fn (open (strcat bvins_dir "\\" gewerk "\\" group "\\" page "\\tsmb.ins") "a"))

              (setq line (strcat dos " ?"))
              (write-line (C_ConvertWINtoDOS line) fn)
              (setq fn    (close fn))
              (setq bnam  dos)
              (setq dos   (strcat bvins_dir "\\" gewerk "\\" group "\\" page "\\" dos))

              ;wenn einer von beiden gesetzt, auf Layer "0" schalten
              (setvar "CLayer" "0")
              (command "._mslide" dos)

              (entdel e )         ;  Hier wird  der Basispunkt und nicht der
                                  ;  Endpunkt gelscht
              (command "_undo" "_g")
              (command "_.block" bnam ip asw "")
              (command "_.zoom" "_w" ll ru)

              (setq ret 0)
              (setvar "pdmode" o_pdmode)
              (setvar "CLayer" Org_Lay)
              (command "_.wblock" dos "=")
              (command "_undo" "_e")

              (if (ms_ask (C_GT "RECOVER_PREV")) (progn
				  (command "_u")
              ))
          )(progn
              (command "_.zoom" "_w" ll ru)
              (entdel (entlast))
			  (entdel e)
          )) ; if asw
      )(progn
			(entdel (entlast));1.punkt wieder lschen

      ))
      (setvar "snapmode" o_snapmode)
      (setvar "cecolor"  o_cecolor)
      ;(C_PopVars)
      (olderr)
      (setq ret ret)
  )

  ;********************* BLOCK UND DIA NEU DEFINIEREN **************************
  (defun block_new_def ( / asw p1 p2 ip e bl l_liste ll ru end_pt end_point Org_Lay)
      (newerr "block_new_def > c:msbv")

      (if (setq ip (getpoint (C_GT "INS_POINT"))) (progn
          (setvar  "pdmode"    3)
          (setvar  "cecolor" "1")
          (setq Org_Lay (getvar "CLayer"))
          (command "._point" ip)
          (setq e (entlast))  ; Einfge PUNKT zum Lschen festhalten

          ; Objekte auswhlen
          (prompt (C_GT "SEL_BLOCK_ELEM"))

          (if (setq asw (ssget)) (progn
              (prompt (C_GT "BLOCK_WAIT_MSG"))
              (ssdel e asw) ;FALLS PUNKT IM AUSWAHLSATZ, ENTFERNEN

              (setq l_liste (insert_view_def e)) ;Ausschnt definieren, Ret alten ausschnt
              (setq ll    (car l_liste)) ;low left
              (setq ru    (cdr l_liste)) ;right up


              ;wenn einer von beiden gesetzt, auf Layer "0" schalten
              (setvar "CLayer" "0")

              (command "._mslide" block_nam)

              (entdel e); ispoint-marke lschen
              (setq bl (nth (atoi (substr last_icon 5)) bl_nam_dos))

              (command "_.block" bl ip asw "")
              (command "_.zoom" "_w" ll ru)

              (setvar "pdmode" o_pdmode)
              (setvar "CLayer" Org_Lay)
              (command "_.wblock" block_nam bl)
              (if (ms_ask (C_GT "RECOVER_PREV")) (progn
                  (command "_u")
              ))
          )(progn
              (entdel (entlast))  ;inspoint-marke lschen
              (command "_.zoom" "_w" ll ru)
          )) ; if Auswahlsatz
      )); if Einfgepunkt

      (olderr)
  )


  ;********************* NEUE SEITE ANLEGEN ************************************
  (defun make_page( / l_liste inp page_exist)
      (newerr "make_page > c:msbv")
      (cfg)

        ;-------------------------------------------------
        (defun page_exist( / dir)
            (if (/= inp "") (progn
;;;;                (setq inp (substr inp 1 16))
                (if (member inp dir_msbv) (progn
                    (set_tile "user" inp)
                    (ms_msg  (C_GT "PG_EXISTS"))
                    (mode_tile "user" 2)
                )(progn
                    (setq dir_msbv (append dir_msbv (list inp)))
                    (setq dir      (get_dosnam dir_dos nil))
                    (setq dir_dos  (append dir_dos (list dir)))
                    (setq mk_dir   (strcat bvins_dir "\\" gewerk "\\" group "\\" dir))
                    (setq fn       (strcat mk_dir "\\tsmb.ins"))
                    (done_dialog)
                ))
            )(progn
                (done_dialog)
            ))
        );defun
        ;-------------------------------------------------

      (setq inp "")
      (set_tile "msg" "")
      (if (new_dialog "input0" $TRIC_DCL_ID$) (progn
          (setq l_liste dir_msbv lastpick "seite_anlegen")
          (set_tile "l_label" (C_GT "PG_CREATE"))
          (set_tile "msg" (C_GT "PG_NAME"))
          (mode_tile "user" 2)
          (action_tile "help" "(c_help)")
          (action_tile "user" "(setq inp $value)")
          (action_tile "ok" "(page_exist)")
          (action_tile "cancel" "(setq dir_msbv l_liste)")
          (start_dialog)

          (if (and (/= inp "") (not (equal l_liste dir_msbv))) (progn
              (make_list "page_list" dir_msbv)
              (set_tile "msg" (C_GT "WRITE_FILE"))
              (save_mnu (strcat bvins_dir "\\" gewerk "\\" group "\\tsmb.dir") dir_dos dir_msbv)
              (setq select_page (itoa (1- (length dir_msbv))))
              (cfg)
              (done_dialog 1)
          ))
      )(progn
          (alert (strcat (C_GT "ERR_LOAD_DCL_1") bvdcl_file (C_GT "ERR_LOAD_DCL_2")))
      ))
      (set_tile "msg" (C_GT "SELECT_FUNCTION"))
      (olderr)
      (setq lastpick "msbv_allgemein")
  )  ;make_page()


  ;********************* TEXT EDITIEREN UND LISTE UPDATEN **********************
  (defun text_edit (var / old inp fn l_liste subst_txt)
      (newerr "text_edit > c:msbv")

      (setq lastpick "text_edit")  ;HILFE
      (setq inp      "")
      (set_tile "msg" "")

      (if (not (new_dialog "input0" $TRIC_DCL_ID$)) (progn
          (alert (C_GT "ERR_LOAD_DCL"))
          (olderr)
          (exit)
      ))

        ; ----------- subst_text ----------------------------
        (defun subst_txt ( / l1 l2 n in)      ;SUBST kann nicht verwendet werden,
            (setq in (atoi (substr var 5)))   ;Da alle gleichlautenden Texte
            (setq l1 bl_nam_msbv)             ;berschrieben wrden
            (setq l2 '())
            (setq n 0)

            (while (< n (length l1))
                (if (= n in) (progn
                    (setq l2 (append l2 (list inp)))
                )(progn
                    (setq l2 (append l2 (list (nth n l1))))
                ))
                (setq n (1+ n))
            )
            (setq l2 l2)
        ) ; defun subst_text
        ;------------------------------------------------------------

      (setq fn     (strcat bvins_dir "\\" gewerk "\\" group "\\" page "\\tsmb.ins"))
      (setq l_liste  bl_nam_msbv)
      (setq old    (nth (atoi (substr var 5)) bl_nam_msbv))
      (set_tile  "l_label" (C_GT "TEXT_EDIT"))
      (set_tile  "msg"   (C_GT "TEXT_FOR_BLOCK"))
      (set_tile  "user" old)
      (mode_tile "user" 2)

      (action_tile "help"   "(c_help)(mode_tile \"user\" 2)")
      (action_tile "user"   "(setq inp $value)")
      (action_tile "ok"     "(setq bl_nam_msbv (subst_txt)) (done_dialog)")
      (action_tile "cancel" "(setq bl_nam_msbv l_liste)")

      (start_dialog)

      (if (not (equal l_liste bl_nam_msbv)) (progn
          (set_tile var inp)
          (set_tile "msg" (C_GT "WRITE_FILE"))
          (save_mnu fn bl_nam_dos bl_nam_msbv)
      ))
      (set_tile "msg" (C_GT "SELECT_FUNCTION"))
      (setq lastpick "msbv_allgemein")

      (olderr)
  )  ;text_edit()

  ;********************* Blocktext ndern und Liste UPDATEN **********************
  (defun text_update (var / old inp fn l_liste subst_txt)
      (newerr "text_update > c:msbv")

      (setq lastpick "text_update")  ;HILFE
      (setq inp      "")
      (set_tile "msg" "")

        ; ----------- subst_text ----------------------------
        (defun subst_txt2 ( / l1 l2 n in)     ;SUBST kann nicht verwendet werden,
            (setq in (atoi (substr var 5)))   ;da alle gleichlautenden Texte
            (setq l1 bl_nam_msbv)             ;berschrieben wrden
            (setq l2 '())
            (setq n  0)

            (while (< n (length l1))
                (if (= n in) (progn
                    (setq l2 (append l2 (list inp)))
                )(progn
                    (setq l2 (append l2 (list (nth n l1))))
                ))
                (setq n (1+ n))
            )
            (setq l2 l2)
        ) ; defun subst_text
        ;------------------------------------------------------------

      (setq fn (strcat bvins_dir "\\" gewerk "\\" group "\\" page "\\tsmb.ins"))
      (setq l_liste bl_nam_msbv)

      (setq old         (nth (atoi (substr var 5)) bl_nam_msbv))
      (setq inp         $value)
      (setq bl_nam_msbv (subst_txt2))
      ;(action_tile "ok"     "(setq bl_nam_msbv (subst_txt2)) (done_dialog)")
      ;(action_tile "cancel" "(setq bl_nam_msbv liste)")

      ;(start_dialog)

      (if (not (equal l_liste bl_nam_msbv)) (progn
          ;(set_tile "user" inp)
          ;(set_tile "msg" "Schreibe Datei")
          (save_mnu fn bl_nam_dos bl_nam_msbv)
          (setq text inp)
      )(progn
          (setq text old)
      ))
      ;(set_tile "msg" "Bitte Funktion whlen")
      (setq lastpick "msbv_allgemein")

      (olderr)
  ) ; text_update()

  ;********************* GEWERKENAMEN EDITIEREN *********************************
  (defun gewerk_edit (var / old inp fn l_liste gewerk_exist)

      (newerr "gewerk_edit > c:msbv")

      (setq lastpick "gewerk_ndern")  ;HILFE
      (setq inp "")
      (set_tile "msg" "")

      (if (not (new_dialog "input0" $TRIC_DCL_ID$)) (progn
          (alert (strcat (C_GT "ERR_LOAD_DCL_1") bvdcl_file (C_GT "ERR_LOAD_DCL_2")))
          (olderr)
          (exit)
      ))

        ; ---------- gewerk_exist ----------------------
        (defun gewerk_exist ( / dir)
            (if (/= inp "") (progn
;;;;                (setq inp (substr inp 1 16))
                (if (member inp gewerk_nam) (progn
                    (set_tile "user" inp)
                    (ms_msg  (C_GT "GEWERK_EXISTS"))
                    (mode_tile "user" 2)
                )(progn
                    (done_dialog)
                    (setq gewerk_nam (subst inp old gewerk_nam))
                    (set_tile "msg" (C_GT "WRITE_FILE"))
                    (save_mnu bvgrp_file gewerk_dir gewerk_nam)
                ))
            ))
        )
        ;--------------------------------------

      (setq l_liste gewerk_nam)
      (set_tile "l_label" (C_GT "GEWERK_CHANGE"))
      (set_tile "msg" (C_GT "GEWERK_NEW_NAME"))
      (setq old (nth (atoi var) gewerk_nam))
      (set_tile "user" old)
      (mode_tile "user" 2)

      (action_tile "help"   "(c_help)(mode_tile \"user\" 2)")
      (action_tile "user"   "(setq inp $value)")
      (action_tile "ok"     "(gewerk_exist)")
      (action_tile "cancel" "(setq gewerk_nam l_liste)")

      (start_dialog)

      (if (not (equal l_liste gewerk_nam))
          (make_list "gewerk_list" gewerk_nam)
      )
      (set_tile "gewerk_list" select_gewerk)
      (set_tile "msg" (C_GT "SELECT_FUNCTION"))
      (setq lastpick "msbv_allgemein")
      (olderr)
  ) ; gewerk_edit()

  ;********************* GRUPPENNAMEN EDITIEREN *********************************
  (defun group_edit (var / old inp fn l_liste group_exist)

      (newerr "group_edit > c:msbv")

      (setq lastpick "gruppe_ndern")    ;HILFE
      (setq inp      "")

      (set_tile "msg" "")
      (if (not (new_dialog "input0" $TRIC_DCL_ID$)) (progn
          (alert (strcat (C_GT "ERR_LOAD_DCL_1") bvdcl_file (C_GT "ERR_LOAD_DCL_2")))
          (olderr)
          (exit)
      ))

        ; ---------- group_exist ----------------------
        (defun group_exist ( / dir)
            (if (/= inp "") (progn
;;;;                (setq inp (substr inp 1 16))
                (if (member inp group_nam) (progn
                    (set_tile "user" inp)
                    (ms_msg  (C_GT "GROUP_EXISTS"))
                    (mode_tile "user" 2)
                )(progn
                    (done_dialog)
                    (setq group_nam (subst inp old group_nam))
                    (set_tile "msg" (C_GT "WRITE_FILE"))
                    (save_mnu (strcat bvins_dir "\\" gewerk "\\tsmb.dir") group_dir group_nam)
                    ;(save_mnu bvgrp_file group_dir group_nam)
                ))
            ))
        )
        ;--------------------------------------

      (setq l_liste group_nam)
      (set_tile "l_label" (C_GT "GROUP_CHANGE"))
      (set_tile "msg" (C_GT "GROUP_NEW_NAME"))
      (setq old (nth (atoi var) group_nam))
      (set_tile  "user" old)
      (mode_tile "user" 2)

      (action_tile "help"   "(c_help) (mode_tile \"user\" 2)")
      (action_tile "user"   "(setq inp $value)")
      (action_tile "ok"     "(group_exist)")
      (action_tile "cancel" "(setq group_nam l_liste)")

      (start_dialog)

      (if (not (equal l_liste group_nam))
          (make_list "group_list" group_nam)
      )
      (set_tile "group_list" select_group)
      (set_tile "msg" (C_GT "SELECT_FUNCTION"))
      (setq lastpick "msbv_allgemein")
      (olderr)
  ) ; group_edit()

  ;********************* SEITENNAMEN EDITIEREN **********************************
  (defun page_edit (var / old inp fn l_liste page_exist)

      (newerr "page_edit > c:msbv")

      (setq lastpick "seite_ndern") ;HILFE
      (setq inp      "")
      (set_tile "msg" "")
      (if (not (new_dialog "input0" $TRIC_DCL_ID$)) (progn
          (alert (C_GT "ERR_LOAD_DCL"))
          (olderr)
          (exit)
      ))
        ;---------- page_exist ------------------
        (defun page_exist ( / dir)

            (if (/= inp "") (progn
;;;;                (setq inp (substr inp 1 16))
                (if (member inp dir_msbv) (progn
                    (set_tile "user" inp)
                    (ms_msg  (C_GT "PG_EXISTS"))
                    (mode_tile "user" 2)
                )(progn
                    (done_dialog)
                    (setq dir_msbv (subst inp old dir_msbv))
                    (set_tile "msg" (C_GT "WRITE_FILE"))
                    (save_mnu (strcat bvins_dir "\\" gewerk "\\" group "\\tsmb.dir") dir_dos dir_msbv)
                ))
            ))
        )
        ;-------------------------------------------

      (setq l_liste dir_msbv)
      (set_tile "l_label" (C_GT "PG_EDIT"))
      (set_tile "msg" (C_GT "PG_NEW_NAME"))
      (setq old (nth (atoi var) dir_msbv))
      (set_tile    "user" old)
      (mode_tile   "user" 2)
      (action_tile "help"   "(c_help)(mode_tile \"user\" 2)")
      (action_tile "user"   "(setq inp $value)")
      (action_tile "ok"     "(page_exist)")
      (action_tile "cancel" "(setq dir_msbv l_liste)")

      (start_dialog)

      (if (not (equal l_liste dir_msbv))
          (make_list "page_list" dir_msbv)
      )
      (set_tile "page_list" select_page)

      (set_tile "msg" (C_GT "SELECT_FUNCTION"))
      (setq lastpick "msbv_allgemein")

      (olderr)
  ) ; page_edit()

  ;********************* VERZEICHNIS UND DATEINAMEN ERMITTELN ******************
  (defun get_dosnam (l_liste bit / nam fn buf)
      ; bit    = T   --> Die Zeichnung auch durchsuchen
      ; l_liste          enthlt Namen (Gruppen-, Seiten- oder Blocknamen)

      (newerr "get_dosnam > c:msbv")

      (if (setq fn (findfile (strcat bvsld_dir "\\TSMB.INS"))) (progn
          (setq dat (open fn "r"))
          (setq nam (read-line dat))
          (setq nam (C_ConvertDOStoWIN nam))
          (setq dat (close dat))
      ))

      (setq buf "0000000000000000000000000000000000")
      (if (or (not nam) (= nam "")) (progn
          (setq nam "1000000")
      ))
      (setq nam (strcat buf (itoa (1+ (atoi nam)))) nam (substr nam (- (strlen nam) 7)))
      (while (< (strlen nam) 8)
          ; auf 8 stellen erhhen
          (setq nam (strcat "0" nam))
      )
      (if l_liste (progn
          (if bit (progn
              (while (or (tblsearch "block" nam) (member nam l_liste)) ; wie name vorhanden
                  ; auf 8 stellen erhhen
                  (setq nam (strcat buf (itoa (1+ (atoi nam)))))
                  (setq nam (substr nam (- (strlen nam) 7)))
              )
          )(progn
              (while (member nam l_liste)                            ; wie name vorhanden
                  (setq nam (strcat buf (itoa (1+ (atoi nam)))))
                  (setq nam (substr nam (- (strlen nam) 7)))
              )
          ))
      ))
      (if (and (not l_liste) bit) (progn
          (while (tblsearch "block" nam)                        ; wie name vorhanden
              (setq nam (strcat buf (itoa (1+ (atoi nam)))))
              (setq nam (substr nam (- (strlen nam) 7)))
          )
      ))
      (olderr)
      (setq nam nam) ; < RCKGABE DATEINAME
  ) ; get_dosnam()


  ;********************* NEUES GEWERK ANLEGEN ***********************************
  (defun make_gewerk ( / l_liste inp gewerk_exist)
      (newerr "make_gewerk > c:msbv")

        (defun gewerk_exist ( / dir)
            (if (/= inp "") (progn
;;;;                (setq inp (substr inp 1 16))
                (if (member inp gewerk_nam) (progn
                    (set_tile "user" inp)
                    (ms_msg  (C_GT "GEWERK_EXISTS"))
                    (mode_tile "user" 2)
                )(progn
                    (setq gewerk_nam (append gewerk_nam (list inp)))
                    (setq dir        (get_dosnam gewerk_dir nil))
                    (setq gewerk_dir (append gewerk_dir (list dir)))
                    (setq mk_dir     (strcat bvins_dir "\\" dir))
                    (setq fn         (strcat mk_dir "\\tsmb.dir"))
                    (done_dialog)
                ))
            )(progn
                (done_dialog)
            ))
        )

      (setq inp "")
      (set_tile "msg" "")
      (if (new_dialog "input0" $TRIC_DCL_ID$) (progn
          (setq l_liste gewerk_nam lastpick "gewerk_anlegen")
          (set_tile "l_label" (C_GT "GEWERK_CREATE"))
          (set_tile "msg"   (C_GT "GEWERK_NAME"))
          (mode_tile "user" 2)
          (action_tile "help" "(c_help)")
;;;;          (action_tile "help" "(acad_helpdlg bvhelp_file lastpick)")
          (action_tile "user" "(setq inp $value)")
          (action_tile "ok" "(gewerk_exist)")
          (action_tile "cancel" "(setq gewerk_nam l_liste)")

          (start_dialog)

          (if (not (equal l_liste gewerk_nam)) (progn
              (make_list "gewerk_list" gewerk_list)
              (save_mnu bvgrp_file gewerk_dir gewerk_nam)
              (setq select_gewerk (itoa (1- (length gewerk_dir))))
              (setq select_group  "0")
              (setq select_page   "0")

              (cfg)
              (done_dialog 1)
          ))
      )(progn
          (alert (strcat (C_GT "ERR_LOAD_DCL_1") bvdcl_file (C_GT "ERR_LOAD_DCL_2")))
      ))
      (set_tile "msg" msg)
      (setq lastpick "msbv_allgemein")
      (olderr)
  ) ; make_gewerk()


  ;********************* NEUE GRUPPE ANLEGEN ***********************************
  (defun make_group ( / l_liste inp group_exist)
      (newerr "make_group > c:msbv")

        (defun group_exist ( / dir)
            (if (/= inp "") (progn
;;;;                (setq inp (substr inp 1 16))
                (if (member inp group_nam) (progn
                    (set_tile "user" inp)
                    (ms_msg  (C_GT "GROUP_EXISTS"))
                    (mode_tile "user" 2)
                )(progn
                    (setq group_nam (append group_nam (list inp)))
                    (setq dir       (get_dosnam group_dir nil))
                    (setq group_dir (append group_dir (list dir)))
                    (setq mk_dir    (strcat bvins_dir "\\" gewerk "\\" dir))
                    (setq fn        (strcat mk_dir "\\tsmb.dir"))
                    (done_dialog)
                ))
            )(progn
                (done_dialog)
            ))
        )

      (setq inp "")
      (set_tile "msg" "")
      (if (new_dialog "input0" $TRIC_DCL_ID$) (progn
          (setq l_liste    group_nam)
          (setq lastpick "gruppe_anlegen")
          (set_tile "l_label" (C_GT "GROUP_CREATE"))
          (set_tile "msg"   (C_GT "GROUP_NAME"))
          (mode_tile "user" 2)
          (action_tile "help"   "(c_help)")
;;;;          (action_tile "help"   "(acad_helpdlg bvhelp_file lastpick)")
          (action_tile "user"   "(setq inp $value)")
          (action_tile "ok"     "(group_exist)")
          (action_tile "cancel" "(setq group_nam l_liste)")

          (start_dialog)

          (if (not (equal l_liste group_nam)) (progn
              (make_list "group_list" group_list)
              ;(save_mnu bvgrp_file group_dir group_nam)
              (save_mnu (strcat bvins_dir "\\" gewerk "\\tsmb.dir") group_dir group_nam)
              (setq select_group (itoa (1- (length group_dir))))
              (setq select_page "0")
              (cfg)
              (done_dialog 1)
          ))
      )(progn
          (alert (strcat (C_GT "ERR_LOAD_DCL_1") bvdcl_file (C_GT "ERR_LOAD_DCL_2")))
      ))
      (set_tile "msg" msg)
      (setq lastpick "msbv_allgemein")
      (olderr)
  )  ; make_group()

  ;;----------------------------------------------------------------------------
  ;********************* VERZWEIGUNG DER FUNKTIONEN ****************************

  (defun action( / x y)

      (newerr "action > c:msbv")

      (if $key (progn
          (cond
              ((= $key "gewerk_pop")
                  (setq x (get_popup gewerk_pop))

                  (cond
                      ((= x (C_GT "S_CREATE"))   ;"Anlegen"
                          (if (= (start_lock) 1) (progn
                              (make_gewerk)
                              (end_lock)
                          )); if gesperrt?
                      )

                      ((= x (C_GT "S_DELETE"))     ; "Lschen"
                          (if (= (start_lock) 1) (progn
                              (setq lastpick "GRUPPE_LSCHEN")
                              (if gewerk (progn
                                  (if (ms_ask (C_GT "GEWERK_DELETE")) (progn
                                      (gewerk_del)
                                      (done_dialog 8)
                                  ))
                              )(progn
                                  (ms_msg (C_GT "GEWERK_NOT_PRES"))
                              ))
                              (end_lock)
                          ));if gesperrt
                      )

                      ((= x (C_GT "S_CHANGE"))    ;"ndern"
                          (if (= (start_lock) 1) (progn
                              (setq lastpick "Gewerk_ndern")
                              (if gewerk (progn
                                  (gewerk_edit select_gewerk)
                              )(progn
                                  (ms_msg (C_GT "GEWERK_NOT_PRES"))
                              ))
                              (end_lock)
                          )) ; if gesperrt
                      )

                      ((= x (C_GT "S_POSITION"))   ; "Position"
                          (if (= (start_lock) 1) (progn
                              (if gewerk (progn
                                  (if (> (length gewerk_nam) 1) (progn
                                      (pos_liste 0)
                                  ))
                              )(progn
                                  (ms_msg (C_GT "GEWERK_NOT_PRES"))
                              ))
                              (end_lock)
                          )) ; if gesperrt
                      )
                  ) ; cond
              ) ; gewerk_pop

              ((= $key "group_pop")
                  (setq x (get_popup group_pop))

                  (cond
                      ((= x (C_GT "S_CREATE"))   ;"Anlegen"
                          (if (= (start_lock) 1) (progn
                              (make_group)
                              (end_lock)
                          )); if gesperrt?
                      )

                      ((= x (C_GT "S_DELETE"))     ; "Lschen"
                          (if (= (start_lock) 1) (progn
                              (setq lastpick "GRUPPE_LSCHEN")
                              (if group (progn
                                  (if (ms_ask (C_GT "GROUP_DELETE")) (progn
                                      (group_del)
                                      (done_dialog 8)
                                  ))
                              )(progn
                                  (ms_msg (C_GT "GROUP_NOT_PRES"))
                              ))
                              (end_lock)
                          )) ; if gesperrt
                      )

                      ((= x (C_GT "S_CHANGE"))    ;"ndern"
                          (if (= (start_lock) 1) (progn
                              (setq lastpick "Gruppe_ndern")
                              (if group (progn
                                  (group_edit select_group)
                              )(progn
                                  (ms_msg (C_GT "GROUP_NOT_PRES"))
                              ))
                              (end_lock)
                          )) ; if gesperrt
                      )

                      ((= x (C_GT "S_POSITION"))   ; "Position"
                          (if (= (start_lock) 1) (progn
                              (if group (progn
                                  (if (> (length group_nam) 1) (progn
                                      (pos_liste 1)
                                  ))
                              )(progn
                                  (ms_msg (C_GT "GROUP_NOT_PRES"))
                              ))
                              (end_lock)
                          )) ; if gesperrt
                      )
                  )
              ) ; group_pop

              ((= $key "page_pop")
                  (setq x (get_popup page_pop))

                  (cond
                      ((= x (C_GT "S_CREATE"))    ;; anlegen
                          (if (= (start_lock) 1) (progn
                              (if group (progn
                                  (make_page)
                              )(progn
                                  (ms_msg (C_GT "GROUP_NOT_PRES"))
                              ))
                              (end_lock)
                          )); if gesperrt
                      )

                      ((= x (C_GT "S_COPY"))    ;; "Kopieren"
                          (if (= (start_lock) 1) (progn
                              (setq lastpick "Seite_kopieren")
                              (if page (progn
                                  (if bl_nam_dos (progn
                                      (if (copy_move_page 2) (progn
                                          (done_dialog 8)
                                      ))
                                  )(progn
                                      (ms_msg (C_GT "PG_EMPTY"))
                                  ))
                              )(
                                  (ms_msg (C_GT "PG_NO_PRESENT"))
                              ))
                              (setq lastpick "msbv_allgemein")
                              (end_lock)
                          )) ;if gesperrt
                      )

                      ((= x (C_GT "S_MOVE"))   ; "Verschieben"
                          (if (= (start_lock) 1) (progn
                              (setq lastpick "Seite_verschieben")
                              (if page (progn
                                  (if bl_nam_dos (progn
                                      (if (copy_move_page 1) (progn
                                          (done_dialog 8)
                                      ))
                                  )(progn
                                      (ms_msg (C_GT "PG_EMPTY"))
                                  ))
                              )(progn
                                  (ms_msg (C_GT "PG_NO_PRESENT"))
                              ))
                              (setq lastpick "msbv_allgemein")
                              (end_lock)
                          )) ; if gesperrt
                      )

                      ((= x (C_GT "S_DELETE"))
                          (if (= (start_lock) 1) (progn
                              (setq lastpick "Seite_lschen")
                              (if page (progn
                                  (if bl_nam_dos (progn
                                      (if (ms_ask (C_GT "PG_DEL_NOT_EMPTY")) (progn
                                          (del_page)
                                      ))
                                  )(progn
                                       (del_page)
                                  ))
                              )(progn
                                  (ms_msg (C_GT "PG_NO_PRESENT"))
                              ))
                              (end_lock)
                          )) ; if gesperrt
                      )

                      ((= x (C_GT "S_CHANGE"))
                          (if (= (start_lock) 1) (progn
                              (setq lastpick "Seite_ndern")
                              (if page (progn
                                  (page_edit select_page)
                              )(progn
                                  (ms_msg (C_GT "PG_NO_PRESENT"))
                              ))
                              (end_lock)
                          )) ; if gesperrt
                      )

                      ((= x (C_GT "S_POSITION"))
                          (if (= (start_lock) 1) (progn
                              (if page (progn
                                  (if (> (length dir_dos) 1) (progn
                                      (pos_liste 2)
                                  ))
                              )(progn
                                  (ms_msg (C_GT "PG_NO_PRESENT"))
                              ))
                              (end_lock)
                          )) ; if gesperrt
                      )
                  ) ; cond
              )   ;page_pop

              ; POPUP MODUS, x1 y1 z1 <0 etc. <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
              ((= $key "insert_mod")
                  (set_tile "msg" (C_GT "S_INSERT_MODE"))
                  (setq modus              (atoi $value))
                  (setq select_insert_mod  $value)
              )

              ; POPUP ANLEGEN, LSCHEN etc. <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
              ((= $key "insert_def")
                  (setq x (get_popup insert_def))

                  (cond
                      ((= x (C_GT "S_CREATE"))  ;; BLOCK NEU
                          (if (= (start_lock) 1) (progn
                              (if page (progn
                                  (if (< (length bl_nam_dos) 12) (progn
                                      (done_dialog 3)
                                  )(progn
                                      (ms_msg (C_GT "PAGE_FULL"))
                                  ))
                              )(progn
                                  (ms_msg (C_GT "PG_NO_PRESENT"))
                              ))
                              (end_lock)
                          )) ; if gesperrt
                      ) ; Anlegen

                      ((= x (C_GT "S_REDEFINE"))    ; BLOCK NEU DEFINIEREN
                          (if (= (start_lock) 1) (progn
                              (if page (progn
                                  (if block_nam (progn
                                      (done_dialog 6)
                                  )(progn
                                      (ms_msg (C_GT "NO_BLOCK_SEL"))
                                  ))
                              )(progn
                                  (ms_msg (C_GT "PG_NO_PRESENT"))
                              ))
                              (end_lock)
                          )) ; if gesperrt
                      )

                      ((= x (C_GT "S_COPY"))    ; BLOCK KOPIEREN
                          (if (= (start_lock) 1)(progn
                              (if page (progn
                                  (if block_nam (progn
                                     (if (setq x (bl_move_copy 2)) (progn
                                         (done_dialog 8)
                                     ))
                                  )(progn
                                     (ms_msg (C_GT "NO_BLOCK_SEL"))
                                  ))
                              )(progn
                                (ms_msg (C_GT "PG_NO_PRESENT"))
                              ))
                              (end_lock)
                          )); if gesperrt
                      )

                      ((= x (C_GT "S_MOVE"))    ;; BLOCK VERSCHIEBEN
                          (if (= (start_lock) 1) (progn
                              (if page (progn
                                  (if block_nam (progn
                                      (if (setq x (bl_move_copy 1)) (progn
                                          (cond
                                              ((= x 1)
                                                  (set_tile "group_list" select_group)
                                                  (if group_dir (progn
                                                      (show_group select_group)
                                                  ))
                                                  (mode_tile "load_new" 1)
                                                  (setq block_nam nil)
                                              )
                                              ((= x 2)
                                                  (done_dialog 8)
                                              )
                                          ) ; cond
                                      ))
                                  )(progn
                                      (ms_msg (C_GT "NO_BLOCK_SEL"))
                                  )) ; if blocknam
                              )(progn
                                  (ms_msg (C_GT "PG_NO_PRESENT"))
                              )) ; if page
                              (end_lock)
                          )); if gesperrt
                      ) ; Verschieben

                      ((= x (C_GT "S_DELETE"))    ;; BLOCK UND DIA LSCHEN
                          (if (= (start_lock) 1) (progn
                              (set_tile "msg" "")
                              (if block_nam (progn
                                  (setq lastpick "block_lschen");HILFE
                                  (if (ms_zoom "Delete" block_nam (C_GT "BLOCK_DEL_1") (C_GT "BLOCK_DEL_2")) (progn
                                      (setq bl_nam_dos  (del_elem_liste (nth (atoi (substr last_icon 5)) bl_nam_dos)  bl_nam_dos ))
                                      (setq bl_nam_msbv (del_elem_liste (nth (atoi (substr last_icon 5)) bl_nam_msbv) bl_nam_msbv))
                                      (save_mnu (strcat bvins_dir "\\" gewerk "\\" group "\\" page "\\tsmb.ins") bl_nam_dos bl_nam_msbv)
                                      (done_dialog 4)
                                  ))
                              )(progn
                                  (ms_msg (C_GT "NO_BLOCK_SEL"))
                              )) ;if
                              (set_tile "msg" msg)
                              (end_lock)
                          )) ; if gesperrt
                      ) ;Lschen

                  ) ;cond
              );POPUP insert_def

              ; Skalierfaktor aus Popup-Liste <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
              ((= $key "skal_pop")
                  (setq skal_wert (get_popup skal_pop))
                  (if (>= (atoi $value) 1) (progn
                      (setq select_skal $value)
                      (setq select_skal_box skal_wert)
                      (set_tile "skal_box" skal_wert)
                  )(progn
                      (set_tile "skal_box" "")
                  ))
              )

              ; Skalierfaktor frei eingeben <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
              ((= $key "skal_box")
                  (setq skal_wert $value)
                  (set_tile "skal_pop" "0")
                  (setq select_skal "0")
                  (setq select_skal_box $value)
              )


              ; BLOCK NEU LADEN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
              ((= $key "load_new")
                  (done_dialog 7)
              )

              ; ATTRIBUTE BEIM EINFGEN EDITIEREN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
              ((= $key "einf_ohne")
                  (set_tile "einf_ohne"   "1")
                  (set_tile "einf_dialog" "0")
                  ;(set_tile "einf_abfr"   "0")
                  (setq ins_al 0)
              )

              ((= $key "einf_dialog")
                  (if (= (get_tile "einf_xref") "0") (progn
                      (set_tile "einf_ohne"   "0")
                      (set_tile "einf_dialog" "1")
                      ;(set_tile "einf_abfr"   "0")
                      (setq ins_al 1)
                  )(progn
                      (set_tile "einf_ohne"   "1")
                      (set_tile "einf_dialog" "0")
                      ;(set_tile "einf_abfr"   "0")
                      (setq ins_al 0)
                  ))
              )

              ; ALS XREF EINFGEN  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
              ((= $key "einf_xref")
                  (if (= (get_tile "einf_xref") "1") (progn
                      ; wenn als xref einfuegen, dann koennen keine Attribute editiert werden
                      (setq ins_xref 1)
                      (set_tile "einf_ohne"   "1")
                      (set_tile "einf_dialog" "0")
                      ;(set_tile "einf_abfr"   "0")
                      (setq ins_al 0)
                  )(progn
                      (setq ins_xref 0)
                  ))
              )


              ; DIA ZOOMEN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
              ((= $key "zoom")
                  (set_tile "msg" "")
                  (if block_nam (progn
                      (setq lastpick "zoom")
                      (ms_zoom "Slide" block_nam "-- ZOOM DIA --" "")
                  )(progn
                      (ms_msg (C_GT "NO_BLOCK_SEL"))
                  ))
                  (set_tile "msg" msg)
              )

              ; OK, ABBRUCH und HILFE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
              ((= $key "cancel") (done_dialog 0))
              ((= $key "help")   (c_help))
              ((= $key "ok")
;;                (if pick_block (progn
;;                    (if (or (tblsearch "block" pick_block) (findfile (strcat block_nam ".DWG"))) (progn
;;                        (done_dialog 2)
;;                    )(progn
;;                        (ms_msg (C_GT "BLOCK_CANT_FIND"))
;;                    ))
;;                )(progn
;;                    (ms_msg (C_GT "NO_BLOCK_SEL"))
;;                ))
                  (cfg)
                  (done_dialog 0)
              )

              ; ARCHIVIEREN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
              ((= $key "arc") (done_dialog 15))

              ; RESTORE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
              ((= $key "res") (done_dialog 16))

              ; FREIGABE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
              ((= $key "dellock") (done_dialog 18))

              ; TSAbout <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
              ((= $key "info") (done_dialog 17))

              ; GRUPPEN ZUM GEWERK ANZEIGEN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
              ((= $key "gewerk_list")
                  (setq select_group "0") ;GRUPPE SETZEN
                  (setq select_page  "0")
                  (setq lastpick     "gewerk")
                  (show_gewerk $value)
              )

              ; SEITEN ZUR GRUPPE ANZEIGEN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
              ((= $key "group_list")
                  (setq select_page "0")    ;SEITE SETZEN
                  (setq lastpick    "gruppe")
                  (show_group $value)
              )

              ; ICONS ZUR SEITE ANZEIGEN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
              ((= $key "page_list")
                  (setq lastpick "seite")
                  (show_page $value)
              )

              ; BLOCKNAMEN ERMITTELN GEGEBENENFALLS EINFGEN <<<<<<<<<<<<<<<<<<<<<<
              ((= (substr $key 1 4) "icon")
                  ;(set_tile "msg" (C_GT "BLOCK_INSERT"))
                  (setq block_nam (get_block $key))  ;BLOCKNAMEN SETZEN
                  (setq lastpick  "icon")            ; HILFE
                  (setq last_icon $key)


                  (if (tblsearch "block" pick_block) (progn
                      (mode_tile "load_new" 0)
                  )(progn
                      (mode_tile "load_new" 1)
                  ))

                  (if (/= first_icon last_icon) (progn
                      (setq x (dimx_tile $key) y (dimy_tile $key))
                      ; Fenster markieren
                      (setq first_icon last_icon)
                  ))
                  (if(= $reason 4) (progn
                      (if (or (tblsearch "block" pick_block) (findfile (strcat block_nam ".DWG"))) (progn
                          (done_dialog 2)    ;Bei Doppelklick Block einfgen
                      )(progn
                          (ms_msg (C_GT "BLOCK_CANT_FIND"))
                      ))
                  ))
              )

              ; TEXT ZUM BLOCK <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
              ((= (substr $key 1 4) "text")
                  (setq old_block_nam block_nam)
                  (setq block_nam (get_block $key))    ;Blocknamen setzen
                  (setq lastpick "text_zum_block")     ;Hilfe
                  (setq nr        (substr $key 5))     ;Nr des textfeldes
                  (setq text      (nth (atoi (substr $key 5)) bl_nam_msbv))

                  ;(set_tile "msg" "Text Editieren (Klick)")
                  (if (or (= $reason 1) (= $reason 2)) (progn
                      ;Bei ENTER Text editieren
                      (if (= (start_lock) 1) (progn
                          (text_update $key)
                          (end_lock)
                      )) ; if gesperrt
                  )); if
                  (set_tile $key text)
              )

              (T (set_tile "msg" msg))
          ) ; cond $key
          (set_tile "msg" msg)
      )) ; if $key
      (olderr)

      (set_tile  "gewerk_pop"  (C_GT "SELECT_FUNC"))
      (set_tile  "group_pop"   (C_GT "SELECT_FUNC"))
      (set_tile  "page_pop"    (C_GT "SELECT_FUNC"))

  ) ; Funktion "Action"


  ;;----------------------------------------------------------------------------
  ;; Lock - Datei loeschen und anschliessend neu anlegen
  (defun msbv_clear_lock (/ LockFile)
      (setq LockFile (strcat bvsld_dir "\\BLOCK.LOC") )
      (C_Del Lockfile)
      (msbv_login)
  ) ; msbv_clear_lock

  ;;----------------------------------------------------------------------------

  (defun Read_Cfg_Entry (The_File Default_Val / zeile Result)
      (setq Result Default_Val)
      (if (setq zeile (read-line The_File)) (progn
          (setq zeile (C_ConvertDOStoWIN zeile))
          (if (/= (setq zeile (substr zeile 1 8)) "") (progn
              (setq Result zeile)
          ))
      ))
      (setq Result Result)
  )

;********************* MSBV MAIN *********************************************
; -------- Hauptprogramm ------------------------------------------------------

    (if (= $TRIC_DCL_ID$ nil) (exit))
    (if (<= $TRIC_DCL_ID$ 0)  (exit))

    (msbv_login)
    (setq c 1)

    (while (> c 0)
        (if (not (new_dialog "msbv0" $TRIC_DCL_ID$)) (progn
            (alert (strcat (C_GT "ERR_LOAD_DCL_1") bvdcl_file (C_GT "ERR_LOAD_DCL_2")))
            (olderr)
            (exit)
        ))
        (if (findfile bvcfg_file) (progn
            (setq fn    (open bvcfg_file "r"))
            ;; skip first line, it's just a comment
            (setq zeile (read-line fn))
            ;; get all the variables needed
            (setq select_gewerk     (itoa (atoi (Read_Cfg_Entry fn "0"))))
            (setq select_group      (itoa (atoi (Read_Cfg_Entry fn "0"))))
            (setq select_page       (itoa (atoi (Read_Cfg_Entry fn "0"))))
            (setq select_insert_mod (itoa (atoi (Read_Cfg_Entry fn "0"))))
            (setq select_al         (itoa (atoi (Read_Cfg_Entry fn "0"))))
            ; soll als xref eingefgt werden
            (setq ins_xref          (atoi (Read_Cfg_Entry fn "0")))
            ; Skalierfaktor
            (setq select_skal       (Read_Cfg_Entry fn "1"))
            ; Skalierfaktor freie Eingabe
            (setq select_skal_box   (Read_Cfg_Entry fn "1:1"))

            (setq fn (close fn))
        )(progn
           ; else - bvcfg_file nicht gefunden
            (setq select_gewerk     "0")
            (setq select_group      "0")
            (setq select_page       "0")
            (setq select_insert_mod "0")
            (setq select_al         "0")
            (setq select_skal       "1")
            (setq select_skal_box "1:1")
        )) ;if bvcfg_file

        (setq l_liste (gen_liste bvgrp_file) ; GEWERK-LISTE ERSTELLEN
              gewerk_dir (car l_liste)       ; GEWERK-LISTE VERZEICHNISSE (DOS)
              gewerk_nam (cdr l_liste)       ; GEWERK-LISTE VERZEICHNISSE (MSBV)
              gewerk_pop (list (C_GT "SELECT_FUNC") (C_GT "S_CREATE") (C_GT "S_DELETE")   (C_GT "S_CHANGE") (C_GT "S_POSITION"))
              group_pop  (list (C_GT "SELECT_FUNC") (C_GT "S_CREATE") (C_GT "S_DELETE")   (C_GT "S_CHANGE") (C_GT "S_POSITION"))
              page_pop   (list (C_GT "SELECT_FUNC") (C_GT "S_CREATE") (C_GT "S_COPY")     (C_GT "S_MOVE")   (C_GT "S_DELETE") (C_GT "S_CHANGE") (C_GT "S_POSITION"))
              insert_def (list (C_GT "S_CREATE") (C_GT "S_REDEFINE") (C_GT "S_COPY")   (C_GT "S_MOVE")   (C_GT "S_DELETE"))
              insert_mod (list (C_GT "S_INS1")   (C_GT "S_INS2")     (C_GT "S_INS3")   (C_GT "S_INS4")   (C_GT "S_INS5"))
              skal_pop   (list (C_GT "S_FREE_ENTRY") "1:1" "1:2" "1:5" "1:10" "1:20" "1:50" "1:100" "1:200" "1:500" "1:1000"
                         "1000:1" "500:1" "200:1" "100:1" "50:1" "20:1" "10:1" "5:1" "2:1")

              lastpick   "Blockverwaltung"        ;HELPINDEX AUF ALLGEMEINE HILFE SETZEN
              modus     (atoi select_insert_mod)  ;EINFGEMODUS
              ins_al    (atoi select_al)
              first_icon ""
              last_icon ""
              block_nam nil
              skal_wert select_skal_box
              msg (C_GT "SELECT_FUNCTION")
              e (entlast)
              Xref_Char (C_GT "XRef_Mode")
        )

        (set_tile "l_label" (C_GT "TRICSY_TITLE"))
        (icon_disable)
        (make_list "gewerk_pop"  gewerk_pop)
        (set_tile  "gewerk_pop"  (C_GT "SELECT_FUNC"))
        (make_list "group_pop"   group_pop)
        (set_tile  "group_pop"   (C_GT "SELECT_FUNC"))
        (make_list "page_pop"    page_pop)
        (set_tile  "page_pop"    (C_GT "SELECT_FUNC"))
        (make_list "skal_pop"    skal_pop)
        (set_tile  "skal_pop"    select_skal)
        (set_tile  "skal_box"    select_skal_box)
        (make_list "insert_def"  insert_def)
        (make_list "insert_mod"  insert_mod)
        (make_list "gewerk_list" gewerk_nam)
        (set_tile  "gewerk_list" select_gewerk)
        (if gewerk_dir (show_gewerk select_gewerk))
        ;(make_list "group_list" group_nam)
        ;(set_tile  "group_list" select_group)
        ;(if group_dir (show_group select_group))
        (set_tile "insert_mod" select_insert_mod)

        (set_tile "einf_ohne"   "0")
        (set_tile "einf_dialog" "0")
        ;(set_tile "einf_abfr"   "0")
        (cond
            ((= ins_al 0)
                (set_tile "einf_ohne" "1")
            )
            ((= ins_al 1)
                (set_tile "einf_dialog" "1")
            )
        ) ; cond

        (if (= ins_xref 1) (progn
            (set_tile "einf_xref"   "1")
            (set_tile "einf_ohne"   "1")
            (set_tile "einf_dialog" "0")
        )(progn
            (set_tile "einf_xref" "0")
        ))
        (mode_tile "load_new" 1)

        ;------ Dialog starten -------------
        (setq c (start_dialog))

        ;------ Dialog auswerten -----------
        (Block_Insert gewerkname)

        (cond
            ((= c 1)
                (dir_exist mk_dir fn)  ;; VERZEICHNIS ANLEGEN
            )

            ((= c 2)                             ; Block einfgen
                ;Skal_Faktor aus dem String skal_wert ermitteln
                (setq wert_len (strlen skal_wert))
                (setq skal_faktor 0)

                ;Laenge des Wertes
                (if (> wert_len 0) (progn
                    (setq wert "")
                    ;Wert vor ':'
                    (setq wert_a "")
                    ;Wert nach ':'
                    (setq wert_b "")
                    ;skal_wert einzeln auslesen und auf ':' achten
                    (setq i 1)
                    (while (<= i wert_len)
                        (if (/= (substr skal_wert i 1) ":") (progn
                            (setq wert (strcat wert (substr skal_wert i 1)))
                        )(progn
                            (setq wert_a wert)
                            (setq wert "")
                        ))
                        (setq i (1+ i))
                    )
                    (setq wert_b wert)
                    ;skal_faktor nur berechnen,wenn Werte Zahlen enthalten
                    (if (and (> (atof wert_b) 0) (> (atof wert_a) 0)) (progn
                        (setq skal_faktor (/ (atof wert_b) (atof wert_a)))
                    ))
                    (if (= skal_faktor nil) (progn
                        (setq skal_faktor 0)
                    ))
                ))
                ;wenn kein Skalierwert eingetragen ist, kein Einfuegen moeglich
                (if (= skal_faktor 0) (progn
                    (ms_msg (C_GT "NO_SCAL_SEL"))
                )(progn

                    (cfg)
                    (setq vblock  "0")  ; kein verschachtelter Block
                    (setq c         0)
                    (setq block_ok  2)
                    (setq insert_ok 1)

                    (if (not (tblsearch "block" pick_block)) (progn
                        ; Einfgen ohne Attribute-Editieren
                        ; beim Einfgen eines Blocks als ext. Referenz, darf der Block
                        ;  nicht in der Zeichnung vohanden sein
                        (if (= ins_xref 0) (progn
                            (setvar "ATTREQ" 0)
                            (command strInsert block_nam '(0 0 0) "x" skal_faktor skal_faktor skal_faktor 0)
                            (entdel (entlast))
                        ))
                    )(progn
                       ; Block ist bereits vorhanden
                       (setq block_ok (cdr (assoc 70 (tblsearch "block" pick_block))))
                       ;(princ block_ok ) Anzeige des Gruppencodes 70
                       ; wenn XREF - Block
                       (if (= block_ok XRef_Test_Val) (progn
                           ; Block ist bereits als XREF vorhanden, dann ist kein Block-Ein-
                           ; fuegen  moeglich   ACAD = 36,  Bricscad = 100
                           (if (= ins_xref 0) (progn
                               (setq insert_ok  0)
                               (setq lastpick   "XREF")
                               (ms_msg (C_GT "XREF_THERE"))
                           ))
                       )(progn
                           ; Block ist bereits als Stammblock vorhanden, dann ist kein xref
                           ;  moeglich      ACAD = 2, Bricscad = 0
                           (if (= ins_xref 1) (progn
                               (setq insert_ok  0)
                               (setq lastpick   "BLOCK_XREF")
                               (ms_msg (C_GT "BLOCK_THERE"))
                           ))
                       ))
                    ))
                    (setq ins_blk_name pick_block)
                    ; Systemvariablen fr das Editieren der Attribute setzen
                    (cond
                        ((= ins_al 0)
                            (setvar "ATTREQ" 0)
                            (setvar "ATTDIA" 0)
                        )
                        ((= ins_al 1)
                            ; Dialogfenster fuer Attribute oeffnen, funktioniert nur noch
                            ; mit dem Befehl initdia
                            ;(initdia)
                            (setvar "ATTREQ" 1)
                            (setvar "ATTDIA" 1)
                        )
                        ((= ins_al 2)
                            (setvar "ATTREQ" 1)
                            (setvar "ATTDIA" 0)
                        )
                    ) ; cond

                    (if (= insert_ok 1) (progn
                        (setvar "cmdecho" 1)
                        (cond
                            ((= modus 0)
                                (setvar "cmdecho" 0)
                                (if (= ins_xref 1) (progn
                                    (command "_.xref" Xref_Char block_nam pause "x" skal_faktor skal_faktor skal_faktor 0)
                                )(progn

                                    (command strInsert ins_blk_name pause "x" skal_faktor skal_faktor skal_faktor 0 )
                                ))
                            )

                            ((= modus 1)
                                (if (= ins_xref 1) (progn
                                    (command "_.xref" "Z" block_nam pause "x" skal_faktor skal_faktor skal_faktor pause)
                                )(progn
                                    (command strInsert ins_blk_name pause "x" skal_faktor skal_faktor skal_faktor pause)
                                ))
                            )

                            ((= modus 2)
                                (if (= ins_xref 1) (progn
                                    (command "_.xref" Xref_Char block_nam pause "x" skal_faktor skal_faktor pause pause)
                                )(progn
                                    (command strInsert ins_blk_name pause "x" skal_faktor skal_faktor pause pause)
                                ))
                            )

                            ((= modus 3)   ; mit Ursprung
                                (if (= ins_xref 1) (progn
                                    (ms_msg (C_GT "XREF_NO_EXPLODE"))
                                )(progn
                                    (command strInsert (strcat "*" pick_block) pause pause pause)
                                ))
                            )

                            ((= modus 4)  ; ACAD-Standard
                                (if (= ins_xref 1) (progn
                                    (command "_.xref" Xref_Char block_nam pause pause pause)
                                )(progn
                                    (command strInsert ins_blk_name pause pause pause pause)
                                ))
                            )

                            (T (setq lastpick "einfge_al") (ms_help) (setq c 1))
                        ) ;cond
                        (setvar "cmdecho" 0)
                    ))

                    (end_lock)
                ));Skalierfaktor
            )

            ((= c 3) ;BLOCK ERSTELLEN
                (cfg)
                (setq c (make_block))
                (end_lock)
            )

            ((= c 4) ;BLOCK UND DIA LSCHEN
                (cfg)
                (setq line (strcat  block_nam ".*"))
                (C_DEL line)
                (end_lock)
            )

            ((= c 6);BLOCK NEU DEFINIEREN
                (cfg)
                (block_new_def)
                (end_lock)
            )

            ((= c 7);BLOCK NEU LADEN
              (cfg)
              ; Beim Laden keine Attribute editieren
              (setvar "ATTREQ" 0)
              (command strInsert (strcat pick_block "=" block_nam) '(0 0 0) "x" 1 1 1 0)
              (entdel (entlast))
            )

            ((= c 8);DOS_OPERATIONEN
            )

            ((= c 9)  ;Neu zeichnen
            )

            ((= c 15) ;Archivieren
                (cfg)
                ; Archivprogramm aufrufen, Verzeichnisnamen der aktuellen
                ; Gewerk und Gewerkenamen bergeben, sowie Flag fr Blockverwaltung
                (setq groupname  (nth (atoi select_group) group_nam))
                (setq gewerkname (nth (atoi select_gewerk) gewerk_nam))
;;;;            (ms:msblkarc gewerk group groupname "1")
                (ms:msblkarc gewerk group gewerkname "1")
            )

            ((= c 16) ;Restore
                (cfg)
                ; Restoreprogramm aufrufen, Flag fr Blockverwaltung bergeben
                (ms:msblkres gewerk "1")
            )

            ((= c 18) ;Freigabe
                (cfg)
                ; Freigabe aufrufen
                (msbv_clear_lock)
            )

            ((= c 17) ;TSAbout
                (cfg)
                ; TRICSyAbout aufrufen
                (c:tricsyinfo)
            )
        ) ;cond Dialog
    ) ; while
    (msbv_logout)
    (olderr)

    (unload_dialog $TRIC_DCL_ID$)
    (setq $TRIC_DCL_ID$ nil)
)
(prompt "OK\n")

